{
  open FspParser
  exception Eof
}

rule token = parse
    [' ' '\t' '\n']                                {token lexbuf}
  | '('                                            {LPAR}
  | ')'                                            {RPAR}
  | '{'                                            {LCUR}
  | '}'                                            {RCUR}
  | ','                                            {COMA}
  | '.'                                            {DOT}
  | ':'                                            {COL}
  | '='                                            {EQU}
  | '|'                                            {DIS}
  | "->"                                           {ARR}
  | "END"                                          {END}
  | "STOP"                                         {STOP}
  | "Process"                                      {KEYPROC}
  | "States"                                       {KEYSTATE}
  | "Transitions"                                  {KEYTRANS}
  | ['a'-'z']['a'-'z' 'A'-'Z' '_' '0'-'9']* as act {ACT(act)}
  | (['a'-'z' 'A'-'Z' '_']+ as may) '?'            {MAY(may)}
  | 'Q' (['0'-'9']+ as state)                      {STATE(int_of_string state)}
  | ['0'-'9']+ as nmb                              {INT(int_of_string nmb)}
  | ['a'-'z' 'A'-'Z' '_' '0'-'9']+ as ident        {IDENT(ident)}
  | eof                                            {raise Eof}

(*
rule token = parse
      [' ' '\t' '\n']                          {token lexbuf}
    | '('                                      {print_string "LPAR\t";LPAR}
    | ')'                                      {print_string "RPAR\t";RPAR}
    | '{'                                      {print_string "LCUR\t";LCUR}
    | '}'                                      {print_string "RCUR\t";RCUR}
    | ','                                      {print_string "COMA\t";COMA}
    | '.'                                      {print_string "DOT\t";DOT}
    | ':'                                      {print_string "COL\t";COL}
    | '='                                      {print_string "EQU\t";EQU}
    | '|'                                      {print_string "DIS\t";DIS}
    | "->"                                     {print_string "ARR\t";ARR}
    | "END"                                    {print_string "END\t";END}
    | "Process"                                {print_string "PROC\t";KEYPROC}
    | "States"                                 {print_string "STATE\t";KEYSTATE}
    | "Transitions"                            {print_string "TRANS\t";KEYTRANS}
    | ['a'-'z' 'A'-'Z' '_']+ as act            {print_string "ACT\t";ACT(act)}
    | (['a'-'z' 'A'-'Z' '_']+ as may) '?'      {print_string "MAY\t";MAY(may)}
    | 'Q' (['0'-'9']+ as state)                {print_string "STATENB\t";STATE(int_of_string state)}
    | ['0'-'9']+ as nmb                        {print_string "INT\t";INT(int_of_string nmb)}
    | ['a'-'z' 'A'-'Z' '_' '0'-'9']+ as ident  {print_string "IDENT\t";IDENT(ident)}
    | eof                                      {print_string "EOF\t";raise Eof}
*)
