%{
  open Mts;;
%}

%token <int> STATE INT
%token <string> ACT MAY IDENT
%token KEYPROC KEYSTATE KEYTRANS
%token LPAR RPAR LCUR RCUR COMA DOT COL EQU DIS ARR END STOP

%start main
%type <Mts.parseResult> main
%start triplet
%type <int * string * int> triplet

%%

triplet:
  LPAR INT COMA ACT COMA INT RPAR {($2,$4,$6)}
;

main:
  procname nbstates transitions {{name = $1 ; nbstates = $2 ; trans = $3}}
;

procname:
  KEYPROC COL idoract {$3}
;

nbstates:
  KEYSTATE COL INT {$3}
;

transitions:
  KEYTRANS COL trans {$3}
;

trans:
  idoract EQU STATE COMA realtrans DOT {$5}
;

realtrans:
  onestate {[$1]}
| onestate COMA realtrans {$1::$3}
;

onestate:
  STATE EQU dest {($1,$3)}

dest:
  LPAR outlist RPAR {$2}
| END {[([],-1)]}
| STOP {[([],-1)]}
;

outlist:
  oneout {[$1]}
| oneout DIS outlist {$1::$3}
;

oneout:
  acts ARR STATE {($1,$3)}
;

acts:
  poss {[$1]}
| LCUR actlist RCUR {$2}

actlist:
  poss {[$1]}
| poss COMA actlist {$1::$3}
;

poss:
  ACT {(True,$1)}
| MAY {(Maybe,$1)}
;

idoract:
  IDENT {$1}
| ACT {$1}
;
